<?php
/*
Plugin Name: WP Link Directory
Version: 1.4.1
Plugin URI: http://www.seanbluestone.com/wp-link-directory
Author: Sean Bluestone
Author URI: http://www.seanbluestone.com
Description: A Links Directory for WordPress

Copyright 2008  Sean Bluestone  (email : thedux0r@gmail.com)

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


register_activation_hook(__FILE__, 'wplinkdir_init');
// register_deactivation_hook(__FILE__, 'wplinkdir_uninstall');

add_action('admin_menu', 'wplinkdir_menu');
add_action('wp_head', 'wplinkdir_styling');


function wplinkdir_shortcodes($atts){
	extract(shortcode_atts(array(
		'page' => 'Home',
		'category' => '',
	), $atts));

	if($category){
		return wplinkdir_displaydir($category);
	}

	if($page=='Home'){
		return wplinkdir_displaydir();
	}elseif($page=='Add URL'){
		return wplinkdir_addsite();
	}elseif($page=='Link To Us'){
		return wplinkdir_linkus();
	}elseif($page=='Search'){
		return wplinkdir_search();
	}
}

add_shortcode('wplinkdir', 'wplinkdir_shortcodes');



function wplinkdir_uninstall(){

	// The uninstall function is no longer used as of v1.2 but if you wish to do a clean uninstall and remove everything
	// Then uncomment the line '// register_deactivation_hook(__FILE__, 'wplinkdir_uninstall');' above then deactivate the plugin.

	global $wpdb;
	$table_links = $wpdb->prefix."wplinkdir_links";
	$table_cats = $wpdb->prefix."wplinkdir_cats";

	$wpdb->query("DROP TABLE {$table_links}, {$table_cats}");

	delete_option('wplinkdir_your_url');
	delete_option('wplinkdir_recip_requirement');
	delete_option('wplinkdir_htmlcode');
	delete_option('wplinkdir_htmltags');
	delete_option('wplinkdir_version');
	delete_option('wplinkdir_catsperrow');
	delete_option('wplinkdir_emailme');
	delete_option('wplinkdir_showpr');
	delete_option('wplinkdir_nofollow');
	delete_option('wplinkdir_extrafields');
	delete_option('wplinkdir_extended_info');
	delete_option('wplinkdir_poweredby');
	delete_option('wplinkdir_captcha');
	delete_option('wplinkdir_show_numbers');
}


function wplinkdir_upgrade($Version){
	global $wpdb;
	$table_links = $wpdb->prefix."wplinkdir_links";
	$table_cats = $wpdb->prefix."wplinkdir_cats";

	if(!$Version || $Version==''){

		mysql_query("ALTER TABLE $table_links ADD `name` VARCHAR( 250 ) NOT NULL AFTER `id`");
		mysql_query("ALTER TABLE $table_links ADD `email` VARCHAR( 250 ) NOT NULL AFTER `name`");
		mysql_query("ALTER TABLE $table_links ADD `pr_recip` VARCHAR( 250 ) NOT NULL");
		mysql_query("ALTER TABLE $table_links ADD `date_added` INT NOT NULL");
		mysql_query("ALTER TABLE $table_links ADD `date_modified` INT NOT NULL");

		$Now=time();
		mysql_query("UPDATE $table_links SET date_added = $Now");

		add_option('wplinkdir_orderby','Pagerank Highest to Lowest');
		add_option('wplinkdir_catsperrow',3);
		add_option('wplinkdir_extended_info','more info');
		add_option('wplinkdir_extrafields','Optional');
		add_option('wplinkdir_showpr','Yes');
		add_option('wplinkdir_nofollow','No');
	}elseif($Version>1 && $Version<1.4){
		mysql_query("ALTER TABLE $table_cats ADD `parent` VARCHAR( 250 ) NOT NULL AFTER `title`");
		add_option('wplinkdir_poweredby','Yes');
		add_option('wplinkdir_captcha','Yes');
	}elseif($Version=='1.4'){
		add_option('wplinkdir_show_numbers','No');
	}
	update_option('wplinkdir_version','1.4.1');
}


function wplinkdir_init(){
	global $wpdb;
	$table_links=$wpdb->prefix."wplinkdir_links";
	$table_cats=$wpdb->prefix."wplinkdir_cats";

	$getTable=mysql_query("SHOW TABLES LIKE '$table_links'");

	// Check for existing installation and run upgrade script if found else create tables and options
	if(@mysql_result($getTable,0,0)){
		wplinkdir_upgrade(get_option('wplinkdir_version'));
	}else{
		$wpdb->query("CREATE TABLE $table_links (
			`id` INT NOT NULL AUTO_INCREMENT,
			`name` VARCHAR( 250 ) NOT NULL ,
			`email` VARCHAR( 250 ) NOT NULL ,
			`title` VARCHAR( 250 ) NOT NULL ,
			`url` VARCHAR( 250 ) NOT NULL ,
			`description` VARCHAR( 250 ) NOT NULL ,
			`recip_url` VARCHAR( 250 ) NOT NULL ,
			`category` VARCHAR( 100 ) NOT NULL,
			`pr` INT NOT NULL,
			`pr_recip` INT NOT NULL,
			`date_added` INT NOT NULL,
			`date_modified` INT NOT NULL,
			UNIQUE KEY id (id))");

		$Now=time();
		$wpdb->query("INSERT INTO $table_links VALUES('','','','SeanBluestone.com','http://www.seanbluestone.com','Resources and articles on SEO, Link Building, Self Improvement and more.','','Blogs & Blogging','2','','$Now','')")or die(mysql_error());

		$wpdb->query("CREATE TABLE $table_cats (
			`id` INT NOT NULL AUTO_INCREMENT ,
			`title` VARCHAR( 250 ) NOT NULL ,
			`parent` VARCHAR( 250 ) NOT NULL ,
			`description` VARCHAR( 250 ) NOT NULL,
			UNIQUE KEY id (id))");

		$wpdb->query("INSERT INTO $table_cats VALUES('','Blogs & Blogging','','All about the fine art of writing nonsense.')");
		$wpdb->query("INSERT INTO $table_cats VALUES('','Games','','Video gaming, online games and more.')");

		$TempTitle=ucfirst(str_replace('www.','',$_SERVER['HTTP_HOST']));
		add_option('wplinkdir_version','1.4');
		add_option('wplinkdir_your_url','http://'.$_SERVER['HTTP_HOST']);
		add_option('wplinkdir_recip_requirement','Nobody');
		add_option('wplinkdir_htmlcode','<a href="'.$_SERVER['HTTP_HOST'].'">'.$TempTitle.'</a>');
		add_option('wplinkdir_htmltags','<b><i><u>');
		add_option('wplinkdir_orderby','Pagerank Highest to Lowest');
		add_option('wplinkdir_catsperrow',2);
		add_option('wplinkdir_extended_info','more info');
		add_option('wplinkdir_extrafields','Optional');
		add_option('wplinkdir_captcha','Yes');
		add_option('wplinkdir_emailme','Yes');
		add_option('wplinkdir_showpr','Yes');
		add_option('wplinkdir_nofollow','No');
		add_option('wplinkdir_poweredby','Yes');
	}
}


function wplinkdir_styling(){

	echo '<STYLE>
	div.pr {
		font-size: 6pt;
		color: #000000;
		float: left;
		height: 30px;
		margin-right: 5px;
	}
	div.prg {
		width: 40px;
		border: 1px solid #999999;
		height: 3px;
		font-size: 1px;
	}
	div.prb {
		background: #5eaa5e;
		height: 3px;
		font-size: 1px;
	}
	.wplinkdir_panel {
		border: 1px solid #999999;
		padding: 5px;
	}
	</STYLE>';

}


function wplinkdir_menu(){
	add_menu_page('WP Link Directory', 'WP Link Directory', 8, __FILE__, 'wplinkdir_admin_page');
	add_submenu_page(__FILE__, 'WP Link Directory - Edit Links','Edit Links', 8, 'wplinkdir_editlinks_page', 'wplinkdir_editlinks_page'); 
	add_submenu_page(__FILE__, 'WP Link Directory - Categories','Edit Categories', 8, 'wplinkdir_category_page', 'wplinkdir_category_page'); 
}


function wplinkdir_admin_page(){
	global $wpdb;

	$cat_table = $wpdb->prefix."wplinkdir_cats";
	$links_table = $wpdb->prefix."wplinkdir_links";
	$recip_option=get_option('wplinkdir_recip_requirement');

	// Perform The Cleanse Action by Checking the Reciprocal URLs for Each Link
	if($_POST['action']=='Cleanse'){

		$CleanseDel=$_POST['wplinkdir_cleansedelete'];
		$LinkCountA=$LinkCountB=$DelCount=0;
		$getLinks=mysql_query("SELECT * FROM $links_table WHERE recip_url <> '' AND recip_url <> 'http://'");
		$searchfor='/\<a.*href\="'.preg_quote(get_option('wplinkdir_your_url'),'/').'".*\>.+\<\/a\>/';

		if($recip_option=='Nobody'){
			echo '<div id="message" class="updated fade"><br><strong>Your Reciprocal Requirements option is set to Nobody. This means no sites are required to link back to you and therefor there is nothing to check/cleanse.</strong></div>';
		}else{
			if($recip_option=='Everybody'){
				$recip_option=11;
			}

			while($Link=mysql_fetch_assoc($getLinks)){
				$LinkCountA++;

				if($Link['pr']<$recip_option){
					$LinkCountB++;
					$handle=FALSE;
					$handle=fopen($Link['recip_url'],'r');

					if($handle){
						while(!feof($handle)){
							$contents.=fgets($handle, 4096);
						}
						fclose($handle);

						if(!preg_match($searchfor,$contents)){
							$Output.='We couldn\'t find a reciprocal link on the page '.$Link['recip_url'].' which is the reciprocal URL supplied for '.$Link['title'].' ('.$Link['url'].').';
							if($CleanseDel=='Yes'){
								$DelCount++;
								mysql_query("DELETE FROM $links_page WHERE id = {$Link['id']}");
								$Output.=' The link has been deleted.';
							}
							$Output.='<br>';
						}
					}else{
						$Output.='The reciprocal page for '.$Link['title'].' ('.$Link['url'].') which was at '.$Link['recip_url'].' no longer exists.';
						if($CleanseDel=='Yes'){
							$Output.=' The link has been deleted.';
							$DelCount++;
							mysql_query("DELETE FROM $links_page WHERE id = {$Link['id']}");
						}
						$Output.='<br>';
					}
				}
			}
			echo '<div id="message" class="updated fade">'.$Output."<br><strong>$LinkCountB out of a total of $LinkCountA links were checked and $DelCount link(s) were deleted.</strong></div>";
		}
	}

	if(get_option('wplinkdir_emailme')=='No'){
		$No=' SELECTED';
	}else{
		$Yes=' SELECTED';
	}
	unset($Yes,$No);

	echo '<div class="wrap"><h2>WP Link Directory</h2>

	<form method="post" action="options.php">';

	wp_nonce_field('update-options');

	echo '<table class="form-table">
	<tr valign="top">
	<td><b>Your URL</b></td>
	<td><input type="text" name="wplinkdir_your_url" value="'.get_option('wplinkdir_your_url').'" /></td>
	<td>Your homepage or the URL you want people to link to</td>
	</tr>
	<tr>
	<td><b>Require Reciprocal Links From</b></td>
	<td><select name="wplinkdir_recip_requirement">';

	$recip_options=array('Nobody','1','2','3','4','5','6','7','8','9','Everybody');

	$current_recip_option=get_option('wplinkdir_recip_requirement');

	foreach($recip_options as $option){
		if($current_recip_option==$option){
			$Extra=' SELECTED';
		}else{
			$Extra='';
		}

		if($option!='Everybody' && $option!='Nobody'){
			$optionN='Sites < PR'.$option;
		}else{
			$optionN=$option;
		}
		echo "<option value=\"{$option}\"{$Extra}>{$optionN}</option>";
	}

	echo '</select></td>
	<td>Sites of these specifications will be required to link back to you to add themselves to your directory.</td>
	</tr>
	<tr valign="top">
	<td><b>Reciprocal Link HTML</b></td>
	<td><textarea rows="3" cols="45" name="wplinkdir_htmlcode">'.get_option('wplinkdir_htmlcode').'</textarea></td>
	<td>Enter the HTML people should use to link to your site. This will be displayed on the Link To Us page.</td>
	</tr>
	<tr valign="top">
	<td><b>Allow HTML in Description</b></td>
	<td><input type="text" name="wplinkdir_htmltags" value="'.get_option('wplinkdir_htmltags').'"></td>
	<td>People adding links to your directory will be able to use these HTML tags in their description. If you want to enable bold text, images and linking, for example, you would enter \'&#60;b&#62;&#60;a&#62;&#60;img&#62;\'</td>
	</tr>

	<tr>
	<td><b>Order Links By</b></td>
	<td><select name="wplinkdir_orderby">';

	$OrderBy=array('Newest First'=>'date_added DESC','Oldest First'=>'date_added ASC','Pagerank Highest to Lowest'=>'pr DESC','Pagerank Lowest to Highest'=>'pr ASC','Alphabetical A to Z'=>'title ASC','Alphabetical Z to A'=>'title DESC');

	$Order=get_option('wplinkdir_orderby');

	foreach($OrderBy as $option => $value){
		if($Order==$option){
			$Extra=' SELECTED';
		}else{
			$Extra='';
		}

		echo "<option value=\"{$option}\"{$Extra}>{$option}</option>";
	}

	echo '</select></td>
	<td>The order in which to display links in your directory.</td></tr>
	<tr valign="top">
	<td><b>Categories Per Row</b></td>
	<td><input type="text" name="wplinkdir_catsperrow" value="'.get_option('wplinkdir_catsperrow').'"></td>
	<td>When displaying the categories on the front page of your directory, this is how many will be displayed per row.</td>
	</tr>

	<tr valign="top">
	<td><b>Show Counts?</b></td>';

	unset($Yes,$No);
	if(get_option('wplinkdir_show_numbers')=='No'){
		$No=' SELECTED';
	}else{
		$Yes=' SELECTED';
	}

	echo '<td><select name="wplinkdir_show_numbers"><option'.$No.'>No</option><option'.$Yes.'>Yes</option></select></td>
	<td>On the front page of your directory you can chose to show or hide the number of links in each category. I.e. \'Links (23)\' vs \'Links\'.</td>
	</tr>

	<tr valign="top">
	<td><b>Detailed Info</b></td>
	<td><input type="text" name="wplinkdir_extended_info" value="'.get_option('wplinkdir_extended_info').'"></td>
	<td>By default a <i>read more</i> link is shown for each link where more detailed information about the link is shown. You can change the text of this link or leave this field blank to disable it.</td>
	</tr>
	<tr><td><b>Extra Fields</b></td>
	<td><select name="wplinkdir_extrafields">';

	$ExtraFieldOptions=array('Hidden','Optional','Required');

	$ExtraFields=get_option('wplinkdir_extrafields');

	foreach($ExtraFieldOptions as $option){
		if($ExtraFields==$option){
			$Extra=' SELECTED';
		}else{
			$Extra='';
		}

		echo "<option value=\"{$option}\"{$Extra}>{$option}</option>";
	}

	echo '</select></td>
	<td>You can include Name and E-Mail fields on your Add URL page. Setting to Hidden will not show these fields, Optional will display but not require them and Required will mean that people cannot add their link without supplying a name and email address.</td>
	</tr>
	<tr valign="top">
	<td><b>Require Captcha?</b></td>';

	unset($Yes,$No);
	if(get_option('wplinkdir_captcha')=='No'){
		$No=' SELECTED';
	}else{
		$Yes=' SELECTED';
	}

	echo '<td><select name="wplinkdir_captcha"><option'.$No.'>No</option><option'.$Yes.'>Yes</option></select></td>
	<td>Captcha is a form of checking that the user is human and not a spam-bot. Enabling captcha displays an image on your Add URL page that the user must enter to have their link accepted.</td>
	</tr>
	<tr valign="top">
	<td><b>Email Me?</b></td>';

	unset($Yes,$No);
	if(get_option('wplinkdir_emailme')=='No'){
		$No=' SELECTED';
	}else{
		$Yes=' SELECTED';
	}

	echo '<td><select name="wplinkdir_emailme"><option'.$No.'>No</option><option'.$Yes.'>Yes</option></select></td>
	<td>If set to Yes the script will send you an email (to the WordPress admin email address) each time a new link is added to your directory.</td>
	</tr>
	<tr valign="top">
	<td><b>Display PageRank</b></td>
	<td><select name="wplinkdir_showpr">';

	unset($Yes,$No);
	if(get_option('wplinkdir_showpr')=='Yes'){
		$Yes=' SELECTED';
	}else{
		$No=' SELECTED';
	}

	echo "<option{$Yes}>Yes</option><option{$No}>No</option>";

	unset($Yes,$No);

	echo '</select></td><td>If you don\'t want to display the PR bar next to links set this to No.</td></tr>
	<tr valign="top"><td><b>Use NoFollow?</b></td>
	<td><select name="wplinkdir_nofollow">';

	if(get_option('wplinkdir_nofollow')=='Yes'){
		$Yes=' SELECTED';
	}else{
		$No=' SELECTED';
	}

	echo "<option{$Yes}>Yes</option><option{$No}>No</option>";

	unset($Yes,$No,$Extra);

	echo '</td>
	<td>NoFollow is an HTML attribute that can be used in links. It tells Google and other search engines to ignore the link and not follow it (<a href="http://en.wikipedia.org/wiki/Nofollow">read more</a>). Turning NoFollow on will add rel="nofollow" to all your links.</td></tr>
	<tr><td><b>Display Powered By?</b></td><td><select name="wplinkdir_poweredby">';

	if(get_option('wplinkdir_poweredby')=='Yes'){
		$Yes=' SELECTED';
	}else{
		$No=' SELECTED';
	}

	echo "<option{$Yes}>Yes</option><option{$No}>No</option>";
	echo '</select></td><td>I offer WP Link Directory for free, for everyone, and a link back to my site isn\'t required, but it is appreciated. If selected this will insert a small link on the home page of the directory to the plugins homepage.</td></tr>

	<tr><td colspan="3"><input type="hidden" name="action" value="update" /><input type="submit" name="Submit" value="Save Changes" /></td></tr>
	</table>
	</form><br><br>'.confirm_request('Are you sure?').'

	<h2>Cleanse Links</h2>
	<form method="POST" action="" name="wplinkdir_cleanse">
	<table class="form-table">
	<tr valign="top">
	<td><b>Delete Links?</b><br><select name="wplinkdir_cleansedelete"><option>No</option><option>Yes</option></select></td>
	<td><br><input type="submit" name="action" value="Cleanse" onclick="return confirmation();"></td>
	<td width="70%">Every now and then you should perform a cleanse which checks all the links in your directory to make sure they comply with your Reciprocal Link requirements. If your Reciprocal Link requires All Sites < PR 4, for example, any sites with < PR 4 will be checked.<br>If you set Delete Links to Yes then links which don\'t meet requirements will be deleted, otherwise they will simply be flagged up for you to check and/or delete manually.</td>
	</tr>
	</table>
	</form>
	</div>';
}


function wplinkdir_editlinks_page(){
	global $wpdb,$Link;

	$cat_table = $wpdb->prefix."wplinkdir_cats";
	$links_table = $wpdb->prefix."wplinkdir_links";
	$Tags=get_option('wplinkdir_htmltags');

	echo '<div class="wrap"><h2>Add New Link</h2>';

	if($_POST['Submit']=='Add Link'){

		$category=$wpdb->escape($_POST['entry_category']);
		$url=$wpdb->escape($_POST['entry_url']);

		$handle1=@fopen($_POST['entry_url'],'r');
		if($handle1){
			$url=$wpdb->escape($_POST['entry_url']);
			fclose($handle1);
		}else{
			echo '<div id="message" class="updated fade"><strong>We couldn\'t open the URL you supplied but the link was added anyway. You may want to check it to ensure it exists.</strong></div>';
		}

		$description=$_POST['entry_description'];
		$title=$wpdb->escape(htmlspecialchars($_POST['entry_title']));

		$Rank=getpagerank($url);

		$now=time();
		mysql_query("INSERT INTO $links_table VALUES('','admin','','$title','$url','$description','','$category','$Rank','','$now','')");

		echo '<div id="message" class="updated fade"><strong>'.$title.' Link Added</strong></div>';
	}

	if($_POST['submit']=='Update'){

		$Rank=getpagerank($_POST['url']);
		$Now=time();
		mysql_query("UPDATE $links_table SET title = '".$_POST['title']."', category = '".$wpdb->escape($_POST['category'])."', url = '".$wpdb->escape($_POST['url'])."', description = '".$_POST['description']."', date_modified = $Now WHERE id = ".$wpdb->escape($_POST['id']))or die('naws '.mysql_error());
		echo '<div id="message" class="updated fade"><strong>'.$_POST['title'].' Link Updated</strong></div>';
		unset($_POST);

	}elseif($_POST['submit']=='Delete'){

		mysql_query("DELETE FROM $links_table WHERE id = ".$wpdb->escape($_POST['id']));
		echo '<div id="message" class="updated fade"><strong>'.$wpdb->escape($_POST['title']).' Link Deleted</strong></div>';
		unset($_POST);
	}

	$getCats=mysql_query("SELECT * FROM $cat_table ORDER BY parent ASC");
	$Cats=wplinkdir_sort_categories('Sort',$getCats);

	echo '<form method="POST" action="" name="addsite">
	<table class="form-table">
	<tr><th>Website URL:</th><td><input type="text" name="entry_url" value="http://"></td></tr>
	<tr><th>Website Title:</th><td><input type="text" name="entry_title"></td></tr>
	<tr><th>Category:</th><td><select name="entry_category">'.wplinkdir_sort_categories('Display',$Cats).'</select></td></tr>
	<tr><th valign="top">Description:</th><td><textarea name="entry_description" rows="3" cols="35"></textarea></td></tr>
	<tr><td colspan="2"><input type="submit" name="Submit" value="Add Link"></td></tr>
	</table>
	</form>';

	// JavaScript confirmation request
	echo confirm_request('Are you sure you want to delete this link?').'<h2>Edit Links</h2>';

	unset($Cats,$getCats);
	$getLinks=mysql_query("SELECT * FROM $links_table ORDER BY category ASC");
	$getCats=mysql_query("SELECT * FROM $cat_table ORDER BY parent ASC");

	$Cats=wplinkdir_sort_categories('Sort',$getCats);


	while($Link=mysql_fetch_assoc($getLinks)){
		$Width=$Link['pr']*4;
		$x++;

		echo '<form method="POST" action="" name="form_'.$x.'">
		<input type="hidden" name="id" value="'.$Link['id'].'">
		<table class="form-table">
		<tr><td><div class="pr">PR: '.$Link['pr'].'<div class="prg"><div class="prb" style="width: '.$Width.'px"></div></div></td><td><a href="'.$Link['url'].'">'.$Link['title'].'</a></td></tr>
		<tr><td>Title:</td><td><input type="text" name="title" value="'.$Link['title'].'"></td></tr>

		<tr><td>Category:</td><td><select name="category">'.wplinkdir_sort_categories('Display',$Cats).'</select></td></tr>

		<tr><td>URL:</td><td><input type="text" name="url" value="'.$Link['url'].'" size="50"></td></tr>';

		if($Link['recip_url']!='' && $Link['recip_url']!='http://'){
			echo '<tr><td>Recip Page:</td><td><a href="'.$Link['recip_url'].'">'.$Link['recip_url'].'</a></td></tr>';
		}

		echo '<tr><td>Description:</td><td><textarea rows="2" cols="55" name="description">'.$Link['description'].'</textarea></td></tr>
		<tr><td colspan="2"><input type="submit" name="submit" value="Update"> <input type="submit" name="submit" value="Delete" onclick="return confirmation();"></td></tr>
		</table>
		</form><br><br>';
	}
}


function wplinkdir_sort_categories($Mode='Display',$getCats){
	global $Link;

	if($Mode!='Display'){
		while($Cat=mysql_fetch_assoc($getCats)){
			if($Cat['parent']==''){
				$Cats[$Cat['title']]=array();
			}else{
				if(count($Cats[$Cat['parent']])<1){
					$Cats[$Cat['parent']]=array();
				}
				$Cats[$Cat['parent']][$Cat['title']]=$Cat['title'];
			}
		}
		return $Cats;
	}else{
		foreach($getCats as $Title => $Value){

			$entry.='<option'.($Link['category'] == $Title ? ' SELECTED' : '').'>'.$Title.'</option>';
			$Echoed[$Title]=TRUE;
			@asort($Value);

			foreach($Value as $SubTitle => $SubValue){
				$entry.='<option '.($Link['category'] == $SubTitle ? ' SELECTED' : '').' value="'.$SubTitle.'"> - '.$SubTitle.'</option>';
			}
		}
		return $entry;
	}
}


function wplinkdir_category_page(){
	global $wpdb;

	$cat_table = $wpdb->prefix."wplinkdir_cats";
	$links_table = $wpdb->prefix."wplinkdir_links";

	echo '<div class="wrap"><h2>Categories</h2>';

	if($_POST['submit']=='Add Category'){

		$name=$wpdb->escape($_POST['cat_name']);
		$parent=$_POST['parent'];
		$description=$_POST['description'];

		mysql_query("INSERT INTO $cat_table VALUES ('','$name','$parent','$description')");
		echo '<div id="message" class="updated fade"><strong>'.$name.' Category Added</strong></div>';
		unset($_POST);

	}elseif($_POST['submit']=='Delete'){

		$name=$wpdb->escape($_POST['oldtitle']);
		mysql_query("DELETE FROM $cat_table WHERE title = '{$name}'");
		mysql_query("UPDATE $links_table SET category = '' WHERE category = '{$name}'");
		echo '<div id="message" class="updated fade"><strong>'.$name.' Category Deleted</strong></div>';
		unset($_POST);

	}elseif($_POST['submit']=='Update'){

		$oldname=$wpdb->escape($_POST['oldtitle']);
		$name=$wpdb->escape($_POST['title']);
		$oldparent=$wpdb->escape($_POST['oldparent']);
		$parent=$wpdb->escape($_POST['parent']);
		$description=$_POST['description'];

		mysql_query("UPDATE $cat_table SET title = '$name', parent = '$parent', description = '$description' WHERE title = '{$oldname}'");

		// If category has gone from being a top category to a sub category, change previous sub-categories of the parent to top categories themselves
		if($parent!=$oldparent && $oldparent==''){
			mysql_query("UPDATE $cat_table SET parent = '' WHERE parent = '$oldname'");
		}

		if($name!=$oldname){
			mysql_query("UPDATE $links_table SET category = '$name' WHERE category = '{$oldname}'");
		}

		echo '<div id="message" class="updated fade"><strong>'.$oldname.' Category Updated</strong></div>';
		unset($_POST);
	}


	$getCats=mysql_query("SELECT * FROM $cat_table ORDER BY title ASC");

	if(mysql_num_rows($getCats)>0){
		$x=0;
		echo '<table class="form-table">';

		$getTopCats=mysql_query("SELECT * FROM $cat_table WHERE parent = '' ORDER BY title ASC")or die(mysql_error());

		$TopCats['None']='';
		while($TopCat=mysql_fetch_assoc($getTopCats)){
			$TopCats[$TopCat['title']]=$TopCat['title'];
		}
		unset($TopCat);

		while($Cat=mysql_fetch_assoc($getCats)){
			$getCount=mysql_query("SELECT COUNT(*) as count FROM $links_table WHERE category = {$Cat['title']}'");
			if(!$numlinks=@mysql_result($getCount,0,0)){
				$numlinks=0;
			}

			echo '<form method="POST" action="" name="edit_category_'.$x.'">
			<input type="hidden" name="oldtitle" value="'.$Cat['title'].'">
			<input type="hidden" name="oldparent" value="'.$Cat['parent'].'">
			<tr valign="top"><td><b>Title:</b><br><input type="text" name="title" value="'.$Cat['title'].'"></td>
			<td><b>Sub-Category of: </b><br><select name="parent">';

			if($Cat['parent']==''){
				$Cat['parent']='None';
			}

			foreach($TopCats as $Title => $Value){
				if($Title==$Cat['parent']){
					$Selected=' SELECTED';
				}else{
					$Selected='';
				}
				echo "<option{$Selected} value=\"{$Value}\">{$Title}</option>";
			}

			echo '</select></td>
			<td><b>Description:</b><br><textarea name="description" rows="3" cols="45">'.$Cat['description'].'</textarea></td>
			<td><input type="submit" name="submit" value="Update"><br><input type="submit" name="submit" value="Delete"></td></tr>
			</form>';
		}
		echo '</table><br><br>';
	}

	echo '<h2>Add New Category:</h2><br><br>
	<form method="POST" action="" name="new_category">
	<table class="form-table">
	<tr valign="top"><td><b>Title:</b><br><input type="text" name="cat_name"></td>
	<td><b>Sub-Category of:</b><br><select name="parent">';

	foreach($TopCats as $TopCat){
		echo "<option>{$TopCat}</option>";
	}

	echo '</select></td>
	<td><b>Description:</b><br><textarea name="description" rows="3" cols="45">'.$Cat['description'].'</textarea></td>
	<td><input type="submit" name="submit" value="Add Category"></td></tr>
	</table>
	</form>
	</div>';
}


function wplinkdir_global_stats(){

	// This function simply displays some statistics about the directory.
	// This function isn't used anywhere in the script but is sometimes useful and can be used anywhere you want to display your stats.

	global $wpdb;
	$table_links = $wpdb->prefix."wplinkdir_links";
	$table_cats = $wpdb->prefix."wplinkdir_cats";

	// select * from table order by if(modified > created, modified, created) desc limit 1

	$Version=get_option('wplinkdir_version');
	$getLinks=mysql_query("SELECT COUNT(*) FROM $table_links");
	$getCategories=mysql_query("SELECT COUNT(*) FROM $table_cats");
	$getOldest=mysql_query("SELECT title,url,date_added FROM $table_links ORDER BY date_added ASC LIMIT 1");
	$getNewest=mysql_query("SELECT title,url,date_added FROM $table_links ORDER BY date_added DESC LIMIT 1");
	$getAveragePR=mysql_query("SELECT AVG(pr) FROM $table_links");

	$Cats=mysql_result($getCategories,0,0);
	$Links=mysql_result($getLinks,0,0);
	$AveragePD=number_format($Links/$Cats,1);
	$AveragePR=number_format(mysql_result($getAveragePR,0,0),1);

	$Newest=mysql_fetch_assoc($getNewest);
	$Newest['date_added']=date('F jS Y',$Newest['date_added']);
	$Oldest=mysql_fetch_assoc($getOldest);
	$Oldest['date_added']=date('F jS Y',$Oldest['date_added']);

	echo "<h3>WordPress Link Directory Version $Version</h3>

	WordPress Link Directory has a total of $Links links throughout $Cats categories.<br>
	The newest link, <a href=\"{$Newest['url']}\">{$Newest['title']}</a>, was added on {$Newest['date_added']} while the oldest link <a href=\"{$OLDest['url']}\">{$Oldest['title']}</a>, was added on {$Oldest['date_added']}.<br>
	There are an average of $AveragePD links per category and the average Pagerank is {$AveragePR}.";
}


function wplinkdir_addsite(){
	global $wpdb,$Link;
	$table_links = $wpdb->prefix."wplinkdir_links";
	$table_cats = $wpdb->prefix."wplinkdir_cats";

	$page='';
	$recip_requirement=get_option('wplinkdir_recip_requirement');

	include 'captcha.php';

	if($_POST['Submit']=='Add Link'){

		// Check the captcha code
		if(get_option('wplinkdir_captcha')=='Yes'){
			$captchas = new CaptchasDotNet ('Seans0n', 'FXreSBkiqzBwFajyshKCupz3yzoTyfu5wdVIaFZx','/tmp/captchasnet-random-strings','3600','abcdefghkmnopqrstuvwxyz','6','240','80');

			// Read the form values
			$password=$_REQUEST['entry_captcha'];
			$random_string=$_REQUEST['entry_random'];

			// Check the random string to be valid and return an error message otherwise.
			if (!$captchas->validate ($random_string)){
				return 'Every CAPTCHA can only be used once. The current CAPTCHA has already been used. Please click back, refresh the page and try again.';
			}elseif (!$captchas->verify ($password)){
				return 'You entered the wrong captcha code. Aren\'t you human? Please use back button and reload.';
			}
		}

		$Tags=get_option('wplinkdir_htmltags');
		$ExtraFields=get_option('wplinkdir_extrafields');
		$category=$wpdb->escape($_POST['entry_category']);

		// Check extrafields option and contents of the fields if required
		if($ExtraFields=='Required'){

			if(!isset($_POST['entry_name'])){
				return $page."You didn't enter a name, you will need to fill this in to add your link.";
			}else{
				$name=trim($_POST['entry_name']);
			}

			if(eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $_POST['entry_email'])){
				$email=trim($_POST['entry_email']);
			}else{
				return $page."The E-Mail address you entered ({$_POST['entry_email']}) doesn't appear to be valid. Your link was not added.";
			}

		}elseif($ExtraFields=='Optional'){
			$email=trim($_POST['entry_email']);
			$name=trim($_POST['entry_name']);
		}else{
			$email='';
			$name='';
		}

		// Check URL Exists With fopen
		$handle1=@fopen($_POST['entry_url'],'r');
		if($handle1){
			$url=$wpdb->escape($_POST['entry_url']);
			fclose($handle1);
		}else{
			$page.='The URL you supplied doesn\'t seem to be valid.';
			return $page;
		}

		// Get Hostname (http://www.example.com/dir/file.htm Becomes example.com) To Check For Duplicate Links
		preg_match('@^(?:http://)?([^/]+)@i',$url,$matches);
		$host=$matches[1];
		preg_match('/[^.]+\.[^.]+$/',$host,$matches);
		$shortened_url=$matches[0];

		$getSame=mysql_query("SELECT category FROM $table_links WHERE url LIKE '%{$shortened_url}%'");
		if(@mysql_result($getSame,0,0)!=''){
			$page.="Your site ({$url}) is already in our directory in the ".mysql_result($getSame,0,0)." category.";
			return $page;
		}

		$recip_page=$wpdb->escape($_POST['entry_recip_page']);
		$description=strip_tags($_POST['entry_description'],$Tags);
		$title=htmlspecialchars($_POST['entry_title']);

		if($recip_page=='' || $recip_page=='http://'){
			$Rank=getpagerank($url);
		}else{
			$Rank=getpagerank($url);
		}

		// Check Reciprocal Link Requirements Are Met

		if($recip_requirement!='Nobody'){

			// Only Check For Reciprocal Link if recip_requirement is 'Everybody' or the Pages Rank is Less Than recip_requirement
			if($recip_requirement=='Everybody' || $Rank<$recip_requirement){

				// Check recip page URL is on the same site as the main link using the hostname
				if($recip_requirement!='Nobody' && !stripos($recip_page,$shortened_url)){
					$page.='The reciprocal link page must be somewhere on the domain you are adding.';
					return $page;
				}

				$searchfor='/\<a.*href\="'.preg_quote(get_option('wplinkdir_your_url'),'/').'".*\>.+\<\/a\>/';

				$handle=@fopen($recip_page,'r');
				if($handle){
					while(!feof($handle)){
						$contents.=fgets($handle, 4096);
					}
					fclose($handle);
				}else{
					$page.='The reciprocal URL you supplied doesn\'t seem to exist.';
					return $page;
				}

				if(!preg_match($searchfor,$contents)){
					$page.="We couldn't find a reciprocal link on the page {$recip_page}.";
					return $page;
				}
			}
		}

		// Insert New Link Into Database
		$now=time();
		mysql_query("INSERT INTO $table_links VALUES('','$name','$email','$title','$url','$description','$recip_page','$category','$Rank','','$now','')");
		$page.='Your link ('.$title.') has been added successfully, thanks!';

		// Email Admin New Link Details (If Selected)
		if(get_option('wplinkdir_emailme')=='Yes'){

			$BlogName=get_option('blogname');
			$SiteURL=get_option('siteurl');
			mail(get_option('admin_email'),"$BlogName - New Link Added","This is just a quick message to let you know that someone has added a link to your link directory on $BlogName ($SiteURL).\n\nLink Name: $title (PR $Rank)\nSite URL: $url\n\nYou can edit or delete this link by logging into your admin section. You can turn off email updates by turning the Email Me option in the admin section.");
		}
	}else{
		// Edit Below Here To Change The Add URL Page

		$getCats=mysql_query("SELECT * FROM $table_cats ORDER BY parent ASC");
		$Cats=wplinkdir_sort_categories('Sort',$getCats);
		$Tags=get_option('wplinkdir_htmltags');
		$ExtraFields=get_option('wplinkdir_extrafields');

		$Link['category']=$_GET['cat'];

		if($recip_requirement!='Nobody'){

			if($recip_requirement=='Everybody'){
				$page.='You must link to our site first before you can add yourself to our directory.';
			}else{
				$page.='Sites with a PageRank of less than '.get_option('wplinkdir_recip_requirement').' must first supply a link back to our site.';
			}

			$page.=' You can <a href="'.str_replace('addsite','linkus',$_SERVER['REQUEST_URI']).'">find out how to do that here</a><br><br>';
		}

		$Tags=get_option('wplinkdir_htmltags');
		if($Tags!=''){
			$Tags='<br>HTML tags allowed: '.htmlspecialchars($Tags);
		}

		if($ExtraFields!='Hidden'){
			$Fields='<tr align="left"><td><b>Your Name:</b></td><td><input type="text" name="entry_name"></td></tr>
			<tr align="left"><td><b>Your E-Mail:</b></td><td><input type="text" name="entry_email"></td></tr>';
		}

		$page.='<form method="POST" action="" name="entryform">
		<table>'.$Fields.'
		<tr align="left"><td><b>Website URL:</b></td><td><input type="text" name="entry_url" value="http://"></td></tr>
		<tr align="left"><td><b>Website Title:</b></td><td><input type="text" name="entry_title"></td></tr>
		<tr align="left"><td><b>Category:</b></td><td><select name="entry_category">'.wplinkdir_sort_categories('Display',$Cats).'</select></td></tr>
		<tr align="left"><td valign="top"><b>Description:</b>'.$Tags.'</td><td><textarea name="entry_description" rows="3" cols="35"></textarea></td></tr>';

		if($recip_requirement!='Nobody'){
			$page.='<tr align="left"><td><b>Reciprocal URL:</b></td><td><input type="text" name="entry_recip_page" value="http://"></td></tr>';
		}

		if(get_option('wplinkdir_captcha')=='Yes'){
			$captchas = new CaptchasDotNet ('Seans0n', 'FXreSBkiqzBwFajyshKCupz3yzoTyfu5wdVIaFZx', '/tmp/captchasnet-random-strings','3600', 'abcdefghkmnopqrstuvwxyz','6', '180','70');

			$page.='<tr valign="top">
			<td><b>Captcha:</b></td><td><input type="hidden" name="entry_random" value="'.$captchas->random().'" />
			'.$captchas->image().'<br>
			<sup><a href="'.$captchas->audio_url().'">Phonetic spelling (mp3)</a></sup></td></tr>
			<tr><td><b>Enter Code:</b></td><td><input name="entry_captcha" /></td></tr>';
		}

		$page.='<tr><td colspan="2" align="right"><input type="submit" name="Submit" value="Add Link"></td></tr>
		</table>
		</form>';
	}
	return $page;
}



function wplinkdir_search(){
	global $wpdb,$Ex,$Home;

	// This function displays and handles the Search page

	$table_cats = $wpdb->prefix."wplinkdir_cats";
	$table_links = $wpdb->prefix."wplinkdir_links";

	wplinkdir_styling();

	$ShowPR=get_option('wplinkdir_showpr');
	$DetailedInfo=get_option('wplinkdir_extended_info');

	// Display the search box.

	$page.='<form method="POST" action="'.$_SERVER['REQUEST_URI'].'" name="searchform">
	<table class="wplinkdir_panel"><tr><td><b>Search For:</b></td>
	<td><input type="text" name="Search" value="'.stripslashes($_POST['Search']).'"></td>
	<td><b>Search In:</b></td>
	<td><select name="type"><option>All</option><option>Title</option><option>URL</option><option>Description</option></select></td></tr>
	<tr><td colspan="4" align="right"><input type="submit" name="submit" value="Search"></td></tr>
	</table>
	</form>
	<br><br><br>';

	// Search in URL, title, description or all 3

	if($_POST['Search']){

		$Search=mysql_real_escape_string(trim($_POST['Search']));

		if($_POST['type']=='URL'){
			$getSearchResults=mysql_query("SELECT * FROM $table_links WHERE url LIKE '%$Search%' ORDER BY pr DESC LIMIT 30");
		}elseif($_POST['type']=='Title'){
			$getSearchResults=mysql_query("SELECT * FROM $table_links WHERE title LIKE '%$Search%' ORDER BY pr DESC LIMIT 30");
		}elseif($_POST['type']=='Description'){
			$getSearchResults=mysql_query("SELECT * FROM $table_links WHERE description LIKE '%$Search%' ORDER BY pr DESC LIMIT 30");
		}elseif($_POST['type']=='All'){
			$getSearchResults=mysql_query("SELECT * FROM $table_links WHERE url LIKE '%$Search%' OR title LIKE '%$Search%' OR description LIKE '%$Search%' ORDER BY pr DESC LIMIT 30");
		}

		if(@mysql_num_rows($getSearchResults)==0){
			$page.='<b>No results were found in your search.</b>';
		}

		while($SearchResult=mysql_fetch_assoc($getSearchResults)){
			$x++;

			$page.="<table><tr>";

			if($ShowPR=='Yes'){
				$Width=$SearchResult['pr']*4;
				$page.='<td><div class="pr">PR: '.$SearchResult['pr'].'
				<div class="prg"><div class="prb" style="width: '.$Width.'px"></div></div>
				</td>';
			}

			if($DetailedInfo!=''){
				$DetailedLink=' - <i><a href="'.$Home.$Ex.'id='.$SearchResult['id'].'">'.$DetailedInfo.'</a></i>';
			}

			$page.='<td>'.$x.'. <a target="_blank" href="'.$SearchResult['url'].'"'.$NoFollow.'>'.stripslashes($SearchResult['title']).'</a> - '.$SearchResult['description'].$DetailedLink.'</td>
			</tr></table>';
		}
	}

	return $page;
}


function wplinkdir_displaydir($ShortcodeCat=''){

	// This is the main function which handles processing and displaying the directory to the outside world

	global $wpdb,$Ex,$Home;
	$cat_table = $wpdb->prefix."wplinkdir_cats";
	$links_table = $wpdb->prefix."wplinkdir_links";

	// If the directory is being displayed using a category shortcode like [wplinkdir category="Blogs & Blogging"] then this will process the category for later use
	if($ShortcodeCat!=''){
		$_GET['cat']=$ShortcodeCat=urlencode(html_entity_decode($ShortcodeCat));
	}

	// WordPress has some funny issues with permalinks being confused as $_GET vars.
	// This section is to sort them out and display the 'Home | Add URL | Link To Us' links correctly
	$Ex='?';
	foreach($_GET as $opt => $val){
		if($opt!='cat' && $opt!='act' && $opt!='id'){
			$Ex='&';
		}
	}

	$_SERVER['REQUEST_URI']=preg_replace('/(&|\?)id\=[0-9]*/','',$_SERVER['REQUEST_URI']);

	if($_GET['act']=='addsite'){
		$AddSite=$_SERVER['REQUEST_URI'];
		$LinkUs=str_replace('addsite','linkus',$_SERVER['REQUEST_URI']);
		$Search=str_replace('addsite','search',$_SERVER['REQUEST_URI']);
		$Home=preg_replace('/(\&|\?)act\=(addsite|linkus|search)/','',$_SERVER['REQUEST_URI']);
		if($_GET['cat']){
			$Temp=explode('cat=',$Home);
			$Home=substr($Temp[0],0,-1);
		}
	}elseif($_GET['act']=='linkus'){
		$AddSite=str_replace('linkus','addsite',$_SERVER['REQUEST_URI']);
		$Search=str_replace('linkus','search',$_SERVER['REQUEST_URI']);
		$LinkUs=$_SERVER['REQUEST_URI'];
		$Home=preg_replace('/(\&|\?)act\=(addsite|linkus|search)/','',$_SERVER['REQUEST_URI']);
		if($_GET['cat']){
			$Temp=explode('cat=',$Home);
			$Home=substr($Temp[0],0,-1);
		}
	}elseif($_GET['act']=='search'){
		$AddSite=str_replace('search','addsite',$_SERVER['REQUEST_URI']);
		$LinkUs=str_replace('search','linkus',$_SERVER['REQUEST_URI']);
		$Search=$_SERVER['REQUEST_URI'];
		$Home=preg_replace('/(\&|\?)act\=(addsite|linkus|search)/','',$_SERVER['REQUEST_URI']);
		if($_GET['cat']){
			$Temp=explode('cat=',$Home);
			$Home=substr($Temp[0],0,-1);
		}
	}elseif(!isset($_GET['act']) || $_GET['act']==''){

		if($_GET['cat']){
			$Temp=explode('cat=',str_replace('act=','',$_SERVER['REQUEST_URI']));
			$Home=substr($Temp[0],0,-1);
			$CEx='&';
		}else{
			$Home=$_SERVER['REQUEST_URI'];
			$CEx=$Ex;
		}

		$AddSite=$_SERVER['REQUEST_URI'].$CEx.'act=addsite';
		$LinkUs=$_SERVER['REQUEST_URI'].$CEx.'act=linkus';
		$Search=$_SERVER['REQUEST_URI'].$CEx.'act=search';
	}

	// End of permalinks section


	// Display the links bar, feel free to edit this to alter how the link bar is shown

	if(!isset($ShortcodeCat) || $ShortcodeCat==''){
		$page.='<a href="'.$Home.'">Home</a> | <a href="'.$AddSite.'">Add URL</a> | <a href="'.$LinkUs.'">Link To Us</a> | <a rel="nofollow" href="'.$Search.'">Search</a><br><br>';
	}

	// Now figure out which page the user is viewing and display it

	if($_GET['act']=='addsite'){

		// The Add URL page. The contents of this page are handled by wplinkdir_addsite() function (the previous function, above).
		$page.=wplinkdir_addsite();
		return $page;

	}elseif($_GET['act']=='search'){

		// The Search page, also handled by another function: wplinkdir_search().
		$page.=wplinkdir_search();
		return $page;

	}elseif($_GET['act']=='linkus'){

		// The Link To Us page. This is a pretty simple page so it doesn't have its own function

		$page.='Step 1: Add our URL to your page using this HTML code:<br><br>
		<textarea rows="4" cols="50">'.get_option('wplinkdir_htmlcode').'</textarea><br><br>

		This will generate a link like this:<br><br>
		<div class="wplinkdir_panel">'.get_option('wplinkdir_htmlcode').'</div><br><br>

		Step 2: Add your link to our site using <a href="'.$AddSite.'">this page</a>. You will be added instantly and we will begin sending traffic back to you immediately.';
		return $page;
	}

	if($_GET['id']){

		// Display detailed info on a requested link

		if(!is_numeric($_GET['id'])){
			return $page.'Invalid Request';
		}

		if(get_option('wplinkdir_extended_info')==''){
			return $page.'Detailed information is not available.';
		}

		$getInfo=mysql_query("SELECT * FROM $links_table WHERE id = ".$wpdb->escape($_GET['id']));
		if(@mysql_num_rows($getInfo)<1){
			return $page.'This link has been deleted or does not exist.';
		}
		$Info=mysql_fetch_assoc($getInfo);

		$Temp=explode('id=',$_SERVER['REQUEST_URI']);
		$CatLink=$Temp[0].$Ex.'cat='.urlencode($Info['category']);

		$page.='<table>
		<tr><td width="125" align="center" valign="top"><img src="http://open.thumbshots.org/image.aspx?url='.$Info['url'].'" width="120" height="90" border="1"></td>
		<td valign="top"><a target="_blank" href="'.$Info['url'].'">'.$Info['title'].'</a><br>
		<font size="-2">'.$Info['url'].'</font><br>'.
		$Info['description'].'</td></tr>
		<tr><td>Category:</td><td><a href="'.$CatLink.'">'.$Info['category'].'</a></td></tr>
		<tr><td>Pagerank:</td><td>'.$Info['pr'].'</td></tr>';

		if($Info['name']){
			$page.="<tr><td>Added By:</td><td>{$Info['name']}</td></tr>";
		}

		$page.="<tr><td>Date Added:</td><td>".date('F jS Y',$Info['date_added'])."</td></tr>";

		if($Info['date_modified']){
			$page.='<tr><td>Last Updated:</td><td>'.date('F jS Y',$Info['date_modified']).'</td></tr>';
		}

		$page.='<tr><td colspan="2"><br><br></td></tr>
		<tr><td>Cached Pages:</td>
		<td><a target="_blank" href="http://www.google.com/search?ie=UTF-8&q=site:'.$Info['url'].'">Google</a>, <a target="_blank" href="http://search.yahoo.com/search?p=site:'.$Info['url'].'">Yahoo!</a>, <a target="_blank" href="http://search.msn.com/results.aspx?q=site:'.$Info['url'].'">MSN</a>, <a target="_blank" href="http://www.altavista.com/web/results?q=site:'.$Info['url'].'">AltaVista</a></td>
		</tr>
		<tr><td>Backlinks:</td>
		<td><a target="_blank" href="http://www.google.com/search?ie=UTF-8&q=link:'.$Info['url'].'">Google</a>, <a target="_blank" href="http://search.yahoo.com/search?p=link:'.$Info['url'].'">Yahoo!</a>, <a target="_blank" href="http://search.msn.com/results.aspx?q=link:'.$Info['url'].'">MSN</a>, <a target="_blank" href="http://www.altavista.com/web/results?q=links:'.$Info['url'].'">AltaVista</a></td>
		</tr>';

		$AlexaLink=str_replace('http://','',str_replace('www.','',strtolower($Info['url'])));
		$Pieces=explode('.',$AlexaLink);
		$TLDPos=count($Pieces)-1;
		$DomainPos=$TLDPos-1;
		$TLD=$Pieces[$TLDPos];
		$Domain=$Pieces[$DomainPos];

		$page.='<tr><td>Other Links:</td>
		<td><a target="_blank" href="http://www.alexa.com/data/details/main/'.$AlexaLink.'">Alexa.com Stats</a>, <a target="_blank" href="http://whois.net/whois_new.cgi?d='.$Domain.'&tld='.$TLD.'">Whois.net</a></td>
		</tr>
		</table>';
	}

	if(isset($_GET['cat'])){

		// A category has been selected, display links in this category.

		$ShowNums=get_option('wplinkdir_show_numbers');
		$ShowPR=get_option('wplinkdir_showpr');
		$DetailedInfo=get_option('wplinkdir_extended_info');
		if(!$Order=get_option('wplinkdir_orderby')){
			$Order='Pagerank Highest to Lowest';
		}
		$OrderBy=array('Newest First'=>'date_added DESC','Oldest First'=>'date_added ASC','Pagerank Highest to Lowest'=>'pr DESC','Pagerank Lowest to Highest'=>'pr ASC','Alphabetical A to Z'=>'title ASC','Alphabetical Z to A'=>'title DESC');
		$Cat=urldecode($_GET['cat']);

		$getCat=mysql_query("SELECT parent,description FROM $cat_table WHERE title = '$Cat'");
		$Desc=mysql_result($getCat,0,1);
		$getLinks=mysql_query("SELECT * FROM $links_table WHERE category = '$Cat' ORDER BY {$OrderBy[$Order]}");

		$page.="<h2>$Cat".($ShowNums == 'Yes' ? ' ('.mysql_num_rows($getLinks).')' : '')."</h2>$Desc";

		// Display sub-categories
		if(mysql_result($getCat,0,0)==''){
			$getSubCats=mysql_query("SELECT title,description FROM $cat_table WHERE parent = '$Cat' ORDER BY title ASC");

			if(mysql_num_rows($getSubCats)>0){
				$page.='<br><br>Sub-Categories: <b>';
				while($SubCat=mysql_fetch_assoc($getSubCats)){
					$getNumLinks=mysql_query("SELECT COUNT(*) FROM $links_table WHERE category = '{$SubCat['title']}'");
					$page.='<a href="'.$Home.$Ex.'cat='.urlencode($SubCat['title']).'">'.$SubCat['title'].($ShowNums == 'Yes' ? ' ('.mysql_result($getNumLinks,0,0).')' : '').'</a>, ';
				}
				$page=substr($page,0,-2).'</b><br><br>';
			}
		}

		if(get_option('wplinkdir_nofollow')=='Yes'){
			$NoFollow=' rel="nofollow"';
		}else{
			$NoFollow='';
		}

		while($Link=mysql_fetch_assoc($getLinks)){

			$page.='<table><tr>';

			if($ShowPR=='Yes'){
				$Width=$Link['pr']*4;
				$page.='<td><div class="pr">PR: '.$Link['pr'].'
				<div class="prg"><div class="prb" style="width: '.$Width.'px"></div></div>
				</td>';
			}

			if($DetailedInfo!=''){
				$DetailedLink=' - <i><a href="'.$Home.$Ex.'id='.$Link['id'].'">'.$DetailedInfo.'</a></i>';
			}

			$page.='<td><a target="_blank" href="'.$Link['url'].'"'.$NoFollow.'>'.stripslashes($Link['title']).'</a> - '.$Link['description'].$DetailedLink.'</td>
			</tr></table>';
		}

		$page.='<br><br>';
	}

	if(!isset($_GET['cat']) && !isset($_GET['id']) && !isset($_GET['act'])){
		// Display all the categories, 3 per row is default option value

		$CatsPerRow=get_option('wplinkdir_catsperrow');
		$ShowNums=get_option('wplinkdir_show_numbers');
		$getCats=mysql_query("SELECT * FROM $cat_table WHERE parent = '' ORDER BY title ASC");
		$x=0;

		if(mysql_num_rows($getCats)>0){

			$page.='<table width="100%"><tr valign="top">';

			while($Cat=mysql_fetch_assoc($getCats)){

				$getSubCats=mysql_query("SELECT * FROM $cat_table WHERE parent = '{$Cat['title']}' ORDER BY title ASC LIMIT 3")or die(mysql_error());

				$getLinkCount=mysql_query("SELECT COUNT(*) as count FROM $links_table WHERE category = '{$Cat['title']}'");
				$LinkCount=mysql_result($getLinkCount,0,0);

				if($x==$CatsPerRow){
					$x=1;
					$page.='</tr><tr valign="top"><td class="wplinkdir_panel" width="33%">';
				}else{
					$x++;
					$page.='<td class="wplinkdir_panel" width="33%">';
				}

				if($_GET){
					$E='&';
				}else{
					$E='?';
				}

				$page.='<b><a href="'.$_SERVER['REQUEST_URI'].$E.'cat='.urlencode($Cat['title']).'">'.$Cat['title'].($ShowNums == 'Yes' ? ' ('.$LinkCount.')' : '').'</a></b>';

				// Display sub-categories too
				if(mysql_num_rows($getSubCats)>0){
					$page.='<br><span style="font-size:smaller">';
					while($SubCat=mysql_fetch_assoc($getSubCats)){
						if($ShowNums=='Yes'){
							$getNumSubLinks=mysql_query("SELECT COUNT(*) FROM $links_table WHERE category = '{$SubCat['title']}'");
							$NumLinks=' ('.mysql_result($getNumSubLinks,0,0).')';
						}else{
							$NumLinks='';
						}
						$page.='<a href="'.$_SERVER['REQUEST_URI'].$E.'cat='.urlencode($SubCat['title']).'">'.$SubCat['title'].$NumLinks.'</a>, ';
					}
					$page=substr($page,0,-2).'</span>';
				}

				$page.='<br>'.$Cat['description'].'</td>';
			}

			$page.='</tr></table>';
		}

		if(get_option('wplinkdir_poweredby')=='Yes'){
			$page.='<div align="right"><font size="-2">Powered by <a target="_blank" href="http://www.seanbluestone.com/wp-link-directory">WordPress Link Directory</a></font></div>';
		}
	}

	return $page;
}


function wplinkdir_linkus(){

	// The Link To Us page. You can edit the text below til your hearts content.

	$page.='Step 1: Add our URL to your page using this HTML code:<br><br>
	<textarea rows="4" cols="50">'.get_option('wplinkdir_htmlcode').'</textarea><br><br>

	This will generate a link like this:<br><br>
	<div class="wplinkdir_panel">'.get_option('wplinkdir_htmlcode').'</div><br><br>

	Step 2: Add your link to our site using <a href="'.$AddSite.'">this page</a>. You will be added instantly and we will begin sending traffic back to you immediately.';
	return $page;
}


function StrToNum($Str, $Check, $Magic){
	$Int32Unit = 4294967296; // 2^32

	$length = strlen($Str);
	for ($i = 0; $i < $length; $i++) {
		$Check *= $Magic; 	
		// If the float is beyond the boundaries of integer (usually +/- 2.15e+9 = 2^31), 
		// the result of converting to integer is undefined
		// refer to http://www.php.net/manual/en/language.types.integer.php
		if ($Check >= $Int32Unit) {
			$Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit));
			//if the check less than -2^31
			$Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check;
		}
		$Check += ord($Str{$i}); 
	}
	return $Check;
}

// Genearate a hash for a url

function HashURL($String){
	$Check1 = StrToNum($String, 0x1505, 0x21);
	$Check2 = StrToNum($String, 0, 0x1003F);

	$Check1>>=2; 	
	$Check1=(($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F);
	$Check1=(($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF);
	$Check1=(($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);	

	$T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F );
	$T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 );

	return ($T1 | $T2);
}

// genearate a checksum for the hash string

function CheckHash($Hashnum){
	$CheckByte=0;
	$Flag=0;

	$HashStr=sprintf('%u', $Hashnum);
	$length=strlen($HashStr);

	for($i=$length-1; $i>=0; $i--) {
		$Re=$HashStr{$i};
		if(1===($Flag % 2)){
			$Re+=$Re;
			$Re=(int)($Re/10)+($Re%10);
		}
		$CheckByte+=$Re;
		$Flag++;
	}

	$CheckByte %= 10;
	if (0 !== $CheckByte){
		$CheckByte=10-$CheckByte;
		if (1 === ($Flag % 2) ) {
			if (1 === ($CheckByte % 2)) {
				$CheckByte += 9;
			}
			$CheckByte >>= 1;
		}
	}

	return '7'.$CheckByte.$HashStr;
}

function getpagerank($url){

	$fp = fsockopen("toolbarqueries.google.com", 80, $errno, $errstr, 30);
	if(!$fp){
		echo "$errstr ($errno)<br />\n";
	}else{
		$out="GET /search?client=navclient-auto&ch=".CheckHash(HashURL($url))."&features=Rank&q=info:".$url."&num=100&filter=0 HTTP/1.1\r\n";
		$out.="Host: toolbarqueries.google.com\r\n";
		$out.="User-Agent: Mozilla/4.0 (compatible; GoogleToolbar 2.0.114-big; Windows XP 5.1)\r\n";
		$out.="Connection: Close\r\n\r\n";

		fwrite($fp, $out);

		while(!feof($fp)){
			$data=fgets($fp, 128);
			$pos=strpos($data, "Rank_");
			if($pos===false){} else{
				$pagerank = substr($data, $pos + 9);
				return $pagerank;
			}
		}
		fclose($fp);
	}
}

function confirm_request($Alert='Are you sure?'){

	$back='<script type="text/javascript"><!--
	function confirmation(){
		var answer = confirm("'.$Alert.'");
		if(answer){
			window.location = "'.$_SERVER['RQUEST_URI'].'";
		}else{
			alert(\'Action Cancelled\');
			return false;
		}
	}
	//--></script>';

	return $back;
}

?>